#!/usr/bin/perl -w

# path to config file
$config="/etc/ifmail/killer.conf";





###############################################################################
### Programm #################################################### do't edit ###
###############################################################################
use File::Find qw/&find/;

$ver="[AB]SO Killer v0.7 (c) Sln !";


# check config
open(CFG,"< $config") or die "$config: $!";

(%main,%link,%dir,$passwd,$report,$log,$notice)=();
$i=$j=0;

while(<CFG>){

$main{address}=$1	if /^address\s+([\d:\/\.]+)$/i;
$main{inbound}=$1	if /^inbound\s+(\S+)$/i;
$main{outbound}=[$1,lc($2)]	if /^outbound\s+(\S+)\s+([ab]{1}so)$/i;
$main{areafix}=[$1,$2,$3]	if /^areafix\s+(\S+)\s+(\S+)\s+(\S+)$/i;
$main{filefix}=[$1,$2,$3]	if /^filefix\s+(\S+)\s+(\S+)\s+(\S+)$/i;

$main{delrem}=$1	if /^delrem\s+([01])$/i;
$main{delsnt}=$1	if /^delsnt\s+([01])$/i;
$main{deldup}=$1	if /^deldup\s+([01])$/i;
$main{deltic}=$1	if /^deltic\s+([01])$/i;
$main{ticall}=$1	if /^ticall\s+([01])$/i;
$main{delelo}=$1	if /^delelo\s+([01])$/i;
$main{delunk}=$1	if /^delunk\s+([01])$/i;
$main{testmode}=$1	if /^testmode\s+([01])$/i;

$dir{$j++}=[$1,$2,$3]	if /^dir\s+(\S+)\s+(\S+)\s+(\d+\w)$/i;

$passwd=$1	if /^passwd\s+(\S+)$/i;
$report=$1	if /^report\s+(\S+)$/i;
$log=$1		if /^log\s+(\S+)$/i;
$notice=$1	if /^notice\s+(\S+)$/i;

$link{$1}=[$2,$3,$4,$5,$6,$7,$8,$9,$10,$11,$12] if /^([\d:\/\.\*]+)\s+(\w+)\s+(\w+)\s+(\w+)\s+(\w+)\s+(\S+)\s+(\w+)\s+(\w+)\s+(\S+)\s+(\w+)\s+([\d:\/\.\-]+)\s+([\d:\/\.\-]+)$/i;
}


die "Config error: any params not found" if keys %main != 13;
die "Config error: no links found" unless %link;
-d $main{inbound} || err("$main{inbound}: $!");
-d $main{outbound}[0] || err("$main{outbound}[0]: $!");


uplog("Starting $ver");
uplog("Use demo mode") if $main{testmode};
uplog("Check params compleate");



### parse note ###
if($notice){
 $note=undef;
 open(NOTE,"< $notice") or err("$notice: $!");
   while(<NOTE>){ s/[\r\n]+$//; $note.="$_\r" }
 close(NOTE);
}




### SCAN DIRS #################################################################
uplog("Found ".(keys %dir)." dirs for scan old files");
foreach(sort {$a<=>$b} keys %dir){
 foreach(oldfile($dir{$_}[0],$dir{$_}[1],gettime($dir{$_}[2]))){
  uplog("Remove old file       -> '$_'");
  if($main{testmode} == 0){ unlink($_) or uplog("$_: $!") }
 }
}
### END SCAN DIRS #############################################################




# get found links
undef %lnk;
if($main{outbound}[1] eq 'bso'){
 opendir(O, $main{outbound}[0]);
 @_=readdir(O);
 closedir(O);
  foreach(@_){
   if($_=~/^([0-9A-F]{8}\.)(\wlo|\wut|pnt)$/i){
   $node='2:'.hex(substr $1,0,4).'/'.hex(substr $1,4,4);
     if(lc($2) eq 'pnt'){
     $o="$main{outbound}[0]/$_";
     opendir(O,$o) || (uplog("$o: $!"),next);
     foreach(readdir(O)){ $lnk{$node.'.'.hex(substr $1,4,4)}=[$o,$1] if $_=~/^(0{4}[0-9A-F]{4}\.)(\wlo|\wut)$/i }
     closedir(O);
     }else{ $lnk{"$node.0"}=[$main{outbound}[0],$1] }
   }
  }
}else{
 opendir(O, $main{outbound}[0]);
  foreach(readdir(O)){ $lnk{"$1:$2/$3.$4"}=[$main{outbound}[0],"$1.$2.$3.$4."] if $_=~/^(\d+)\.(\d+)\.(\d+)\.(\d+)\.(\wlo|\wut)$/ }
 closedir(O);
}




(%n,%a,%t,%k,%m)=();

# set params for found link
foreach $i (keys %lnk){
 ($z,$n,$f,$p)=split /[\.\/\:]/, $i;
 $s=undef;
 $s=$link{"*"}            if exists $link{"*"};
 if($p){
  $s=$link{"$z:*/*.*"}    if exists $link{"$z:*/*.*"};
  $s=$link{"$z:$n/*.*"}   if exists $link{"$z:$n/*.*"};
  $s=$link{"$z:$n/$f.*"}  if exists $link{"$z:$n/$f.*"};
  $s=$link{"$z:$n/$f.$p"} if exists $link{"$z:$n/$f.$p"};
 }else{
  $s=$link{"$z:*/*"}      if exists $link{"$z:*/*"};
  $s=$link{"$z:$n/*"}     if exists $link{"$z:$n/*"};
  $s=$link{"$z:$n/$f"}    if exists $link{"$z:$n/$f"};
  $s=$link{"$z:$n/$f.0"}  if exists $link{"$z:$n/$f.0"};
 }

if($s){
 %{$n{$i}}=map {lc($_),''} split //,$s->[0];
 $n{$i}{time}=gettime($s->[1]);
 
 %{$a{$i}}=map {lc($_),''} split //,$s->[2];
 $a{$i}{time}=gettime($s->[3]);
 $a{$i}{pass}=getpass($i,$s->[4],'a');
 
 %{$t{$i}}=map {lc($_),''} split //,$s->[5];
 $t{$i}{time}=gettime($s->[6]);
 $t{$i}{pass}=getpass($i,$s->[7],'t');

 %{$k{$i}}=map {lc($_),''} split //,$s->[8];
 
 if($s->[9]=~/^[\d:\/\.]+$/){ $k{$i}{aka}=$s->[9] }
 elsif($s->[9] eq '-'){       $k{$i}{aka}=$main{address}}
 else{			      err("Check ouraka for $i") }

 if($s->[10]=~/^[\d:\/\.]+$/){ $k{$i}{oaka}=$s->[10] }
 elsif($s->[10] eq '-'){       $k{$i}{oaka}=$i }
 else{			       err("Check aka for $i") }
  
  err("Check netmail keys for $i") if not (exists $n{$i}{a} or exists $n{$i}{b} or exists $n{$i}{c});
  err("Check arcmail keys for $i") if not (exists $a{$i}{a} or exists $a{$i}{b} or exists $a{$i}{c});
  err("Check tics keys for $i")    if not (exists $t{$i}{a} or exists $t{$i}{b} or exists $t{$i}{c});
  err("Check action keys for $i")  if not (exists $k{$i}{a} or exists $k{$i}{b} or exists $k{$i}{c});
  
}else{ delete $lnk{$i} }
}






### START PROCESS OUTBOUND ####################################################
uplog("Found ".(keys %lnk)." links for scan outbound");

foreach $link (sortlnk(keys %lnk)){

uplog("Work with $link");

($path,$file)=@{$lnk{$link}};


### chack outbound path #######################################################
-d $path or (uplog("Outbound path not found ($path)"),next);


### check bsy or csy flag #####################################################
if(-f "$path/$file"."bsy" or -f "$path/$file"."csy"){ uplog("Skip (busy)"); next }


### create bsy ################################################################
open(BSY,"> $path/$file"."bsy") || (uplog("$path/$file"."bsy: $!"),next);
print BSY "$$\n";
close(BSY);


### ?LO #######################################################################

### create %lo ###
(%lo,%cmp,%rmfile)=();
@lo=getfile("[chfid]{1}lo");

foreach $f (@lo){
undef %tmp;$i=0;
 open(LO,"< $path/$f") or (uplog("$path/$f: $!"), next);
 while(<LO>){ chomp($tmp{$i++}=$_) }
 close(LO);
   foreach $n (keys %tmp){
       if($tmp{$n}=~/^([\^\#\~]{1})(.*\/)([^\/]+\.pkt)$/i)                     { $lo{p}{$f}{$n}=[$1,"$2$3",$3] }
    elsif($tmp{$n}=~/^([\^\#\~]{1})(.*\/)([^\/]+\.(su|mo|tu|we|th|fr|sa)\w)$/i){ $lo{a}{$f}{$n}=[$1,"$2$3",$3] }
    elsif($tmp{$n}=~/^([\^\#\~]{1})(.*\/)([^\/]+\.tic)$/i)                     { $lo{t}{$f}{$n}=[$1,"$2$3",$3] }
    elsif($tmp{$n}=~/^(~?)(\/.*?)([^\/]+)$/i)                                  { $lo{f}{$f}{$n}=[$1,"$2$3",$3] }
    else{ uplog("Unknown line in '$f'");
          if($main{delunk} == 1){ uplog("Remove unknown line   -> '$tmp{$n}'") }
          else                  { uplog("Skip unknown line     -> '$tmp{$n}'"); $lo{u}{$f}{$n}=['',$tmp{$n},$tmp{$n}] } }
}
}


### for check of change lo ###
foreach $a (keys %lo){ foreach $b (keys %{$lo{$a}}){ foreach $c (keys %{$lo{$a}{$b}}){ $cmp{$b}{$c}='' }}}




### delete dupes ##############################################################
if($main{deldup}){

undef %dup;
foreach $a (keys %lo){ foreach $b (keys %{$lo{$a}}){ foreach $c (keys %{$lo{$a}{$b}}){
@_=($lo{$a}{$b}{$c}[0],$lo{$a}{$b}{$c}[1]);
 if(exists $dup{$_[1]}){
  $dup{$_[1]}=[$_[0],$c,$b] if $_[0] eq '';
  $dup{$_[1]}=[$_[0],$c,$b] if $_[0] eq '#' and $dup{$_[1]}[0] ne '';
  $dup{$_[1]}=[$_[0],$c,$b] if $_[0] eq '^' and $dup{$_[1]}[0] ne '' and $dup{$_[1]}[0] ne '#';
  $dup{$_[1]}=[$_[0],$c,$b] if $_[0] eq '~' and $dup{$_[1]}[0] ne '' and $dup{$_[1]}[0] ne '#' and $dup{$_[1]}[0] ne '^';
 }else{ $dup{$_[1]}=[$_[0],$c,$b] }
}}}


foreach $a (keys %lo){ foreach $b (keys %{$lo{$a}}){ foreach $c (keys %{$lo{$a}{$b}}){
$_=$lo{$a}{$b}{$c};
 if($dup{$_->[1]}[0] ne $_->[0] or $dup{$_->[1]}[1] ne $c or $dup{$_->[1]}[2] ne $b){
  uplog("Remove duplicate link -> '$_->[1]'");
  delete $lo{$a}{$b}{$c};
 }
}}}

}



### remove not exist files ####################################################
if($main{delrem} == 1){
foreach $a (keys %lo){ foreach $b (keys %{$lo{$a}}){ foreach $c (keys %{$lo{$a}{$b}}){
 unless(-f $lo{$a}{$b}{$c}[1]){
 uplog("Remove empty link     -> '$lo{$a}{$b}{$c}[1]'");
 delete $lo{$a}{$b}{$c};
}}}}
}


### del link sent files #######################################################
if($main{delsnt} == 1){
foreach $a (keys %lo){ foreach $b (keys %{$lo{$a}}){ foreach $c (keys %{$lo{$a}{$b}}){
 if($lo{$a}{$b}{$c}[0] eq '~'){
 uplog("Remove sent file      -> '$lo{$a}{$b}{$c}[1]'");
 delete $lo{$a}{$b}{$c};
}}}}
}



### chk file from tic #########################################################
undef %tic;
foreach $b (keys %{$lo{t}}){ foreach $c (keys %{$lo{t}{$b}}){

 open(TIC, "< $lo{t}{$b}{$c}[1]") or (uplog("$lo{t}{$b}{$c}[1]: $!"), next);
 $fn=undef; while(<TIC>){ $fn=$1 if /^file\s+(\S+)/i }
 close(TIC);
 unless($fn and length($fn)){
 uplog("Bad structure in tic  -> '$lo{t}{$b}{$c}[1]'");
 next;
 }

if($main{ticall} == 1){
  foreach $a (keys %{$lo{f}}){ foreach(keys %{$lo{f}{$a}}){
   if($lo{f}{$a}{$_}[2]=~/^\Q$fn\E$/i and $lo{f}{$a}{$_}[0]=~/^~?$/ and @_=stat($lo{f}{$a}{$_}[1])){
    $tic{$b}{$c}=[$a,$_,$lo{f}{$a}{$_}[1],$lo{f}{$a}{$_}[2],$_[7],$_[9]]; last;
   }
  }}
}else{
  foreach(keys %{$lo{f}{$b}}){
   if($lo{f}{$b}{$_}[2]=~/^\Q$fn\E$/i and $lo{f}{$b}{$_}[0]=~/^~?$/ and @_=stat($lo{f}{$b}{$_}[1])){
    $tic{$b}{$c}=[$b,$_,$lo{f}{$b}{$_}[1],$lo{f}{$b}{$_}[2],$_[7],$_[9]]; last;
   }
  }
}

}}

if($main{deltic} == 1){
foreach $b (keys %{$lo{t}}){ foreach $c (keys %{$lo{t}{$b}}){
 if(not exists $tic{$b}{$c}){
  $rmfile{$lo{t}{$b}{$c}[1]}='';
  uplog("Remove tic w/o file   -> '$lo{t}{$b}{$c}[1]'");
  delete $lo{t}{$b}{$c};
}}}}




### oldest ####################################################################
undef %old;
foreach $a (keys %lo){ foreach $b (keys %{$lo{$a}}){ foreach $c (keys %{$lo{$a}{$b}}){
 if(@_=stat("$lo{$a}{$b}{$c}[1]")){
  push @{$lo{$a}{$b}{$c}},$_[7],$_[9];
  $old{$a}{$b}{$c}='' if $a eq 'p' and time-$_[9] > $n{$link}{time};
  $old{$a}{$b}{$c}='' if $a eq 'a' and time-$_[9] > $a{$link}{time};
  $old{$a}{$b}{$c}='' if $a eq 't' and time-$_[9] > $t{$link}{time};
 }else{
  push @{$lo{$a}{$b}{$c}},0,0;
  uplog("Can't stat            -> '$lo{$a}{$b}{$c}[1]'") }
}}}




### netmail ###################################################################
(%an,%on,%sn)=();
foreach $f (getfile("[ochi]{1}ut")){
 next unless @_=stat("$path/$f");
 $sn{$f}=[$f,$_[7],$_[9]];
 $an{$f}="$path/$f";
 $on{$f}='' if time-$_[9] > $n{$link}{time};
}





### WORK WITH KEYS ############################################################

### chk key 'd' (kill all) ####################################################
if((%old or %on) and exists $k{$link}{d}){

#netmail
foreach(keys %an){
  uplog("Remove all file       -> '$an{$_}'");
  $rmfile{$an{$_}}='';
  push @{$m{$link}}, $sn{$_};
}
#?lo
foreach $a (keys %lo){ foreach $b (keys %{$lo{$a}}){ foreach $c (keys %{$lo{$a}{$b}}){
 if($lo{$a}{$b}{$c}[0] eq '^' or $lo{$a}{$b}{$c}[0] eq '#'){
  uplog("Remove all link       -> '$lo{$a}{$b}{$c}[1]'");
  $rmfile{$lo{$a}{$b}{$c}[1]}='';
 }else{
  uplog("Remove all file       -> '$lo{$a}{$b}{$c}[1]'");
 }
  push @{$m{$link}}, [@{$lo{$a}{$b}{$c}}[2..4]];
  delete $lo{$a}{$b}{$c};
}}}

}else{

### netmail ###
if(exists $old{p} or %on){

 if(exists $n{$link}{c}){
  foreach(keys %an){
   $rmfile{$an{$_}}='';
   push @{$m{$link}}, $sn{$_};
   uplog("Remove all netmail    -> '$an{$_}'");
  }
  foreach $a (keys %{$lo{p}}){ foreach(keys %{$lo{p}{$a}}){
   $rmfile{$lo{p}{$a}{$_}[1]}='';
   push @{$m{$link}},[@{$lo{p}{$a}{$_}}[2..4]];
   uplog("Remove all netmail    -> '$lo{p}{$a}{$_}[1]'");
   delete $lo{p}{$a}{$_};
  }}}

 elsif(exists $n{$link}{b}){
  foreach(keys %on){
   $rmfile{$an{$_}}='';
   push @{$m{$link}}, $sn{$_};
   uplog("Remove old netmail    -> '$an{$_}'");
  }
  foreach $a (keys %{$old{p}}){ foreach(keys %{$old{p}{$a}}){
   $rmfile{$lo{p}{$a}{$_}[1]}='';
   push @{$m{$link}},[@{$lo{p}{$a}{$_}}[2..4]];
   uplog("Remove old netmail    -> '$lo{p}{$a}{$_}[1]'");
   delete $lo{p}{$a}{$_};
  }}}

 elsif(exists $n{$link}{a}){
  foreach(keys %on){
   push @{$m{$link}}, $sn{$_};
   uplog("Found old netmail     -> '$an{$_}'");
  }
  foreach $a (keys %{$old{p}}){ foreach(keys %{$old{p}{$a}}){
   push @{$m{$link}},[@{$lo{p}{$a}{$_}}[2..4]];
   uplog("Found old netmail     -> '$lo{p}{$a}{$_}[1]'");
  }}}
}


### arcmail ###
if(exists $old{a}){

 if(exists $a{$link}{c}){
  foreach $a (keys %{$lo{a}}){ foreach(keys %{$lo{a}{$a}}){
   $rmfile{$lo{a}{$a}{$_}[1]}='';
   push @{$m{$link}},[@{$lo{a}{$a}{$_}}[2..4]];
   uplog("Remove all arc mail   -> '$lo{a}{$a}{$_}[1]'");
   delete $lo{a}{$a}{$_};
  }}}

 elsif(exists $a{$link}{b}){
  foreach $a (keys %{$old{a}}){ foreach(keys %{$old{a}{$a}}){
   $rmfile{$lo{a}{$a}{$_}[1]}='';
   push @{$m{$link}},[@{$lo{a}{$a}{$_}}[2..4]];
   uplog("Remove old arc mail   -> '$lo{a}{$a}{$_}[1]'");
   delete $lo{a}{$a}{$_};
  }}}

 elsif(exists $a{$link}{a}){
  foreach $a (keys %{$old{a}}){ foreach(keys %{$old{a}{$a}}){
   push @{$m{$link}},[@{$lo{a}{$a}{$_}}[2..4]];
   uplog("Found old arc mail    -> '$lo{a}{$a}{$_}[1]'");
  }}}
}


### tic with file ###
if(exists $old{t}){

 if(exists $t{$link}{c}){
  foreach $a (keys %{$lo{t}}){ foreach(keys %{$lo{t}{$a}}){
   $rmfile{$lo{t}{$a}{$_}[1]}='';
   push @{$m{$link}},[@{$lo{t}{$a}{$_}}[2..4]];
   uplog("Remove all tic file   -> '$lo{t}{$a}{$_}[1]'");
   delete $lo{t}{$a}{$_};
     if(exists $tic{$a}{$_}){
     push @{$m{$link}},[@{$tic{$a}{$_}}[3..5]];
     uplog("Remove link from tic  -> '$tic{$a}{$_}[2]'");
     delete $lo{f}{$tic{$a}{$_}[0]}{$tic{$a}{$_}[1]};
     }
  }}}

 elsif(exists $t{$link}{b}){
  foreach $a (keys %{$old{t}}){ foreach(keys %{$old{t}{$a}}){
   $rmfile{$lo{t}{$a}{$_}[1]}='';
   push @{$m{$link}},[@{$lo{t}{$a}{$_}}[2..4]];
   uplog("Remove old tic file   -> '$lo{t}{$a}{$_}[1]'");
   delete $lo{t}{$a}{$_};
     if(exists $tic{$a}{$_}){
     push @{$m{$link}},[@{$tic{$a}{$_}}[3..5]];
     uplog("Remove link from tic  -> '$tic{$a}{$_}[2]'");
     delete $lo{f}{$tic{$a}{$_}[0]}{$tic{$a}{$_}[1]};
     }
  }}}

 elsif(exists $t{$link}{a}){
  foreach $a (keys %{$old{t}}){ foreach(keys %{$old{t}{$a}}){
   push @{$m{$link}},[@{$lo{t}{$a}{$_}}[2..4]];
   uplog("Found old tic file    -> '$lo{t}{$a}{$_}[1]'");
     if(exists $tic{$a}{$_}){
     push @{$m{$link}},[@{$tic{$a}{$_}}[3..5]];
     uplog("Found link from tic   -> '$tic{$a}{$_}[2]'");
     }
  }}}
}

}
### OUTBOUND COMPLEATE ########################################################



### Send mail #################################################################
if(exists $old{a}){
  if($main{areafix}[1] ne '!' and exists $a{$link}{d}){
   uplog("Sent $main{areafix}[1] to $main{areafix}[0]");
   pkt($link,"Point",$k{$link}{aka},$main{areafix}[0],$a{$link}{pass},$main{areafix}[1]) if $main{testmode} == 0;
  }
  if($main{areafix}[2] ne '!' and exists $a{$link}{e}){
   uplog("Sent $main{areafix}[2] to $main{areafix}[0]");
   pkt($link,"Point",$k{$link}{aka},$main{areafix}[0],$a{$link}{pass},$main{areafix}[2]) if $main{testmode} == 0;
  }
}

if(exists $old{t}){
  if($main{filefix}[1] ne '!' and exists $t{$link}{d}){
   uplog("Sent $main{filefix}[1] to $main{filefix}[0]");
   pkt($link,"Point",$k{$link}{aka},$main{filefix}[0],$a{$link}{pass},$main{filefix}[1]) if $main{testmode} == 0;
  }
  if($main{filefix}[2] ne '!' and exists $t{$link}{e}){
   uplog("Sent $main{filefix}[2] to $main{filefix}[0]");
   pkt($link,"Point",$k{$link}{aka},$main{filefix}[0],$a{$link}{pass},$main{filefix}[2]) if $main{testmode} == 0;;
  }
}

if((exists $old{a} or exists $old{t}) and exists $k{$link}{c} and $notice){
 uplog("Sent notice");
 pkt($main{address},"Robot",$k{$link}{oaka},"Point","notice",$note) if $main{testmode} == 0;
}



### REMOVE FILES ##############################################################
if($main{testmode} == 0 and %rmfile){
  foreach(sort keys %rmfile){ unlink($_) || uplog("Can't unlink $_: $!") }
}



### write ?lo file ############################################################

undef %out;
foreach $a (keys %lo){ foreach $b (keys %{$lo{$a}}){ foreach $c (keys %{$lo{$a}{$b}}){
 $out{$b}{$c}=[$a,$lo{$a}{$b}{$c}[0].$lo{$a}{$b}{$c}[1]];
}}}


 foreach $f (@lo){
  undef @out;
  push @out,$out{$f}{$_}[1] foreach(sort {$a<=>$b} keys %{$out{$f}});

  if(scalar(keys %{$cmp{$f}}) == scalar(@out)){
   uplog("Skip unchanged        -> '$path/$f'");
   next;
  }

   if(@out){
    uplog("Write                 -> '$path/$f'");

    if($main{testmode} == 0){
     open(LO, "> $path/$f") or (uplog("$path/$f: $!"), next);
     print LO map {"$_\n"} @out;
     close(LO);
    }

   }else{

    if($main{delelo} == 1){
     uplog("Unlink empty lo       -> '$path/$f'");
     (unlink("$path/$f") or uplog("$path/$f: $!")) if $main{testmode} == 0;
    }else{
      uplog("Keep empty lo         -> '$path/$f'");

     if($main{testmode} == 0){
      open(LO, "> $path/$f") or (uplog("$path/$f: $!"), next);
      print LO '';
      close(LO);
     }

    }
   }
 }




### remove bsy flag ###########################################################
unlink("$path/$file"."bsy") || uplog("$path/$file"."bsy: $!");


### LINK COMPLEATE ############################################################
}





### MAKE REPORT FILE ##########################################################
undef @report;
foreach $n (sortlnk(keys %lnk)){

if(exists $m{$n} and exists $k{$n}{b}){
push @report,"",">$n";
 $ts=$tf=0;
 foreach $t (@{$m{$n}}){
 $_=uc(" $t->[0] ").("."x(17-length $t->[0])).("."x(8-length b2s($t->[1])))." ".b2s($t->[1])."  ".(" "x(8-length t2s($t->[2]))).t2s($t->[2]);
 push @report, $_;
  $tf++;
  $ts+=$t->[1];
 }
   $num='file';
   $num.='s' if $tf > 1;
   push @report, " ".("-"x37)," $tf $num at ".b2s($ts)." bytes";
}
}




### WRITE REPORT ##############################################################
if(@report and $report){
 open(REP,"> $report") or uplog("$report: $!");
  print REP map{"$_\n"} @report,"\n\n$ver";
 close(REP);
  uplog("Make report file      -> '$report'");
}




### FINISH ####################################################################
if(@report){
 uplog("Exit 5 (ok)\n");
#system("/usr/lib/ifmail/st/hpt post -af \"2:5007/16\" -at \"2:5007/16\" -nf \"[AB]SO Killer\" -nt \"All\" -e \"500716.NEWS\" -s \"removed files\" -x -d $report");
 exit(5);
}else{
 uplog("Exit 0 (ok)\n");
 exit(0);
}








### sub programm ##############################################################
sub oldfile {
my ($dir,$mask,$time)=@_;
 my @files;
 $mask=~s/(\W)/\\$1/g;
 $mask=~s/\\\*/\.*/g;
 $mask=~s/\\\?/\.{1}/g;
 find(sub{-f && /^$mask$/ && time-(stat($File::Find::name))[9] > $time && push @files, $File::Find::name}, $dir);
 return(@files);
}



sub getpass {
my ($i,$symb,$key)=@_;
 return '' if $symb eq "-";
 return $symb if $symb ne "-" and $symb ne "!";
 return '' unless $passwd;

 open(PWD,"< $passwd") or err("$passwd: $!");
  my $pass;
  $i=$1.$2.$3 if $i=~/^(\d+:)(\d+\/)(\d+)\.0$/;
  while(<PWD>){ $pass=$1 if /^password\s+\Q$i\E\s+(\S+)/i }
 close(PWD);

  return $pass if $pass;

 if((exists $a{$i}{d} or exists $a{$i}{e}) and $key eq 'a'){ uplog("Areafix password for $i not found (disable sent msg to areafix)"); delete $a{$i}{d}; delete $a{$i}{e} }
 if((exists $t{$i}{d} or exists $a{$i}{e}) and $key eq 't'){ uplog("Filefix password for $i not found (disable sent msg to filefix)"); delete $t{$i}{d}; delete $t{$i}{e} }
}




sub gettime {
 err("Check time param") unless $_[0]=~/^(\d+)([smhd]{1})$/i;
 return $1		if lc($2) eq 's';
 return $1*60		if lc($2) eq 'm';
 return $1*60*60	if lc($2) eq 'h';
 return $1*60*60*24	if lc($2) eq 'd';
}




sub getfile {
 opendir(DIR,$path) or uplog("$path: $!");
 my @file=grep{-f "$path/$_" and $_=~/^\Q$file\E($_[0])$/i} readdir(DIR);
 closedir(DIR);
return(@file);
}



sub sortlnk { map{$_->[0]} sort{$a->[1] <=> $b->[1] || $a->[2] <=> $b->[2] || $a->[3] <=> $b->[3] || $a->[4] <=> $b->[4]} map{[$_, split m![:/.]!]} @_ }



sub pkt {
my ($afrom,$nfrom,$ato,$nto,$subj,$body)=@_;

my @f=split /[:.\/]/,$afrom;
my @t=split /[:.\/]/,$ato;
$f[3]=0 unless $f[3];
$t[3]=0 unless $t[3];

my @d=localtime;
my @m=("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");

my $header =pack("vvvvvvvvvvvvvA8vvvvvvvvvvVvvvvvvv",
	    $f[2],$t[2],$d[5]+1900,$d[4],$d[3],$d[2],$d[1],$d[0],
	    0,2,$f[1],$t[1],254,"",$f[0],$t[0],0,256,2304,1,
	    $f[0],$t[0],$f[3],$t[3],0,2,$f[2],$t[2],$f[1],$t[1],1,0);

my $head=sprintf("%02d",$d[3])." $m[$d[4]] ".(substr $d[5],-2)."  ".sprintf("%02d:%02d:%02d",$d[2],$d[1],$d[0])."\x00$nto\x00$nfrom\x00$subj\x00";

my $cluge ="\x01INTL $t[0]:$t[1]/$t[2] $f[0]:$f[1]/$f[2]\x0D";
$cluge.="\x01TOPT $t[3]\x0D" if $t[3];
$cluge.="\x01FMPT $f[3]\x0D" if $f[3];
$cluge.="\x01MSGID: $afrom ".sprintf("%lx",time)."\x0D";

$body.="\x0D--- $ver\x0D\x00\x00\x00";

my $pktname=sprintf("%lx",time-rand('999999')).".pkt";

open(PKT,"> $main{inbound}/$pktname") or err("$main{inbound}/$pktname: $!");
 print PKT $header.$head.$cluge.$body;
close(PKT);
}



sub err {
 uplog("$_[0]");
 uplog("Exit 1 (err)\n");
 exit(1);
}



sub uplog{
my @t=localtime();
return unless $log;
open(LOG, ">> $log") or die "$log: $!";
 print LOG sprintf("%02d/%02d/%02d %02d:%02d:%02d",$t[3],$t[4],substr($t[5],-2),$t[2],$t[1],$t[0])." killer [$$] $_[0]\n";
close(LOG);
}



sub b2s{
 my $str=shift;
 return "- " if $str=~/^\D+$/;
 return (int($str/1024**3*10)/10)."g" if $str >= 1_000_000_000;
 return (int($str/1024**2*10)/10)."m" if $str >= 1_000_000;
 return (int($str/1024*10)/10)   ."k" if $str >= 1_000;
 return $str."b" if $str;
 "0b";
}


sub t2s{
 return "-     " if $_[0]=~/^\D+$/;
 $_=(time-$_[0])/(86400);
 $_++ if $_!=int($_);
 $_=int($_);
 $_>1 ? "$_ days" : "$_ day ";
}
